Index: /LMDZ6/branches/cirrus/libf/phylmdiso/phys_local_var_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmdiso/phys_local_var_mod.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/phylmdiso/phys_local_var_mod.F90	(revision 5202)
@@ -14,4 +14,8 @@
       REAL, SAVE, ALLOCATABLE :: ql_seri(:,:),qs_seri(:,:)
       !$OMP THREADPRIVATE(ql_seri,qs_seri)
+! SN 15/07/2024 ISO 4D
+      REAL, SAVE, ALLOCATABLE :: qx_seri(:,:,:)
+      !$OMP THREADPRIVATE(qx_seri)
+! SN
       REAL, SAVE, ALLOCATABLE :: qbs_seri(:,:)
       !$OMP THREADPRIVATE(qbs_seri)
@@ -24,4 +28,6 @@
       REAL, SAVE, ALLOCATABLE :: pbl_eps(:,:,:)
       !$OMP THREADPRIVATE(pbl_eps)
+      REAL, SAVE, ALLOCATABLE :: tke_shear(:,:,:), tke_buoy(:,:,:), tke_trans(:,:,:)
+      !$OMP THREADPRIVATE(tke_shear,tke_buoy,tke_trans)
       REAL, SAVE, ALLOCATABLE :: tr_seri(:,:,:)
       !$OMP THREADPRIVATE(tr_seri)
@@ -64,4 +70,8 @@
       REAL, SAVE, ALLOCATABLE :: d_t_eva(:,:),d_q_eva(:,:),d_ql_eva(:,:),d_qi_eva(:,:)
       !$OMP THREADPRIVATE(d_t_eva,d_q_eva,d_ql_eva,d_qi_eva)
+! SN 15/07/2024 ISO 4D
+      REAL, SAVE, ALLOCATABLE :: d_qx_eva(:,:,:)
+      !$OMP THREADPRIVATE(d_qx_eva)
+! SN
       REAL, SAVE, ALLOCATABLE :: d_t_lscst(:,:),d_q_lscst(:,:)
       !$OMP THREADPRIVATE(d_t_lscst,d_q_lscst)
@@ -84,6 +94,6 @@
       REAL, SAVE, ALLOCATABLE :: d_t_vdf_x(:,:), d_q_vdf_x(:,:)
       !$OMP THREADPRIVATE( d_t_vdf_x, d_q_vdf_x)
-      REAL, SAVE, ALLOCATABLE :: d_t_bs(:,:), d_q_bs(:,:), d_qbs_bs(:,:)
-      !$OMP THREADPRIVATE( d_t_bs,d_q_bs, d_qbs_bs)
+      REAL, SAVE, ALLOCATABLE :: d_t_bsss(:,:), d_q_bsss(:,:), d_qbs_bsss(:,:)
+      !$OMP THREADPRIVATE( d_t_bsss,d_q_bsss, d_qbs_bsss)
 !>nrlmd+jyg
       REAL, SAVE, ALLOCATABLE :: d_t_oro(:,:)
@@ -124,4 +134,6 @@
       REAL, SAVE, ALLOCATABLE :: xts_seri(:,:,:)
       !$OMP THREADPRIVATE( xts_seri)
+      REAL, SAVE, ALLOCATABLE :: xtbs_seri(:,:,:)
+      !$OMP THREADPRIVATE( xtbs_seri)
       REAL, SAVE, ALLOCATABLE :: d_xt_eva(:,:,:)
       !$OMP THREADPRIVATE( d_xt_eva)
@@ -134,6 +146,6 @@
       REAL, SAVE, ALLOCATABLE :: d_xt_dyn(:,:,:)
       !$OMP THREADPRIVATE( d_xt_dyn)
-      REAL, SAVE, ALLOCATABLE :: d_xtl_dyn(:,:,:), d_xts_dyn(:,:,:)
-      !$OMP THREADPRIVATE(d_xtl_dyn, d_xts_dyn)
+      REAL, SAVE, ALLOCATABLE :: d_xtl_dyn(:,:,:), d_xts_dyn(:,:,:), d_xtbs_dyn(:,:,:)
+      !$OMP THREADPRIVATE(d_xtl_dyn, d_xts_dyn, d_xtbs_dyn)
       REAL, SAVE, ALLOCATABLE :: d_xt_con(:,:,:)
       !$OMP THREADPRIVATE( d_xt_con)
@@ -166,7 +178,4 @@
       !$OMP THREADPRIVATE(d_ts, d_tr)
 
-! aerosols
-      REAL, SAVE, ALLOCATABLE :: m_allaer (:,:,:)
-      !$OMP THREADPRIVATE(m_allaer)
 ! diagnostique pour le rayonnement
       REAL, SAVE, ALLOCATABLE :: topswad_aero(:),  solswad_aero(:)      ! diag
@@ -292,4 +301,25 @@
 !$OMP THREADPRIVATE(toplwad0_aerop, sollwad0_aerop)
 
+!AI 08 2023 ajout pour Ecrad
+      REAL,ALLOCATABLE,SAVE :: topswad_aero_s2(:), solswad_aero_s2(:)
+!$OMP THREADPRIVATE(topswad_aero_s2, solswad_aero_s2)
+      REAL,ALLOCATABLE,SAVE :: topswai_aero_s2(:), solswai_aero_s2(:)
+!$OMP THREADPRIVATE(topswai_aero_s2, solswai_aero_s2)
+      REAL,ALLOCATABLE,SAVE :: topswad0_aero_s2(:), solswad0_aero_s2(:)
+!$OMP THREADPRIVATE(topswad0_aero_s2, solswad0_aero_s2)
+      REAL,ALLOCATABLE,SAVE :: topsw_aero_s2(:,:), topsw0_aero_s2(:,:)
+!$OMP THREADPRIVATE(topsw_aero_s2, topsw0_aero_s2)
+      REAL,ALLOCATABLE,SAVE :: solsw_aero_s2(:,:), solsw0_aero_s2(:,:)
+!$OMP THREADPRIVATE(solsw_aero_s2, solsw0_aero_s2)
+      REAL,ALLOCATABLE,SAVE :: topswcf_aero_s2(:,:), solswcf_aero_s2(:,:)
+!$OMP THREADPRIVATE(topswcf_aero_s2, solswcf_aero_s2)
+! additional LW variables CK
+      REAL,ALLOCATABLE,SAVE :: toplwad_aero_s2(:), sollwad_aero_s2(:)
+!$OMP THREADPRIVATE(toplwad_aero_s2, sollwad_aero_s2)
+      REAL,ALLOCATABLE,SAVE :: toplwai_aero_s2(:), sollwai_aero_s2(:)
+!$OMP THREADPRIVATE(toplwai_aero_s2, sollwai_aero_s2)
+      REAL,ALLOCATABLE,SAVE :: toplwad0_aero_s2(:), sollwad0_aero_s2(:)
+!$OMP THREADPRIVATE(toplwad0_aero_s2, sollwad0_aero_s2)
+
 !Ajout de celles n??cessaires au phys_output_write_mod
       REAL, SAVE, ALLOCATABLE :: tal1(:), pal1(:), pab1(:), pab2(:)
@@ -300,5 +330,5 @@
 !$OMP THREADPRIVATE(sens, flwp, fiwp)
 !!
-!FC
+!FC 
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: zxfluxt, zxfluxq
 !$OMP THREADPRIVATE(zxfluxt, zxfluxq)
@@ -315,6 +345,6 @@
     REAL, SAVE, ALLOCATABLE,DIMENSION(:,:)          :: d_deltat_wk, d_deltaq_wk
 !$OMP THREADPRIVATE(d_deltat_wk, d_deltaq_wk)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:)            :: d_s_wk, d_dens_a_wk, d_dens_wk
-!$OMP THREADPRIVATE(d_s_wk, d_dens_a_wk, d_dens_wk)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:)            :: d_s_wk, d_s_a_wk, d_dens_wk, d_dens_a_wk
+!$OMP THREADPRIVATE(d_s_wk, d_s_a_wk, d_dens_wk, d_dens_a_wk)
     REAL, SAVE, ALLOCATABLE,DIMENSION(:,:)          :: d_deltat_wk_gw, d_deltaq_wk_gw
 !$OMP THREADPRIVATE(d_deltat_wk_gw, d_deltaq_wk_gw)
@@ -328,5 +358,5 @@
 !!!OMP THREADPRIVATE(d_s_the, d_dens_the)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:)           :: d_deltat_ajs_cv, d_deltaq_ajs_cv
-!$OMP THREADPRIVATE(d_deltat_ajs_cv, d_deltaq_ajs_cv)                       
+!$OMP THREADPRIVATE(d_deltat_ajs_cv, d_deltaq_ajs_cv)
 #ifdef ISO
     REAL, SAVE, ALLOCATABLE,DIMENSION(:,:,:)          :: d_deltaxt_wk
@@ -376,6 +406,7 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxfluxlat, zxtsol, snow_lsc, zxfqfonte
 !$OMP THREADPRIVATE(zxfluxlat, zxtsol, snow_lsc, zxfqfonte)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxrunofflic
-!$OMP THREADPRIVATE(zxrunofflic)
+!SN runoffdiag
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxrunofflic, runoff_diag
+!$OMP THREADPRIVATE(zxrunofflic, runoff_diag)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxqsurf, rain_lsc, rain_num
 !$OMP THREADPRIVATE(zxqsurf, rain_lsc, rain_num)
@@ -383,7 +414,7 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: xtevap,xtprw
 !$OMP THREADPRIVATE(xtevap,xtprw)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: h1_diag,runoff_diag
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: h1_diag
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: xtrunoff_diag
-!$OMP THREADPRIVATE(h1_diag,runoff_diag,xtrunoff_diag)
+!$OMP THREADPRIVATE(h1_diagv,xtrunoff_diag)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:,:) :: zxfxtcalving
 !$OMP THREADPRIVATE(zxfxtcalving)
@@ -581,4 +612,10 @@
       REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: pfraclr,pfracld
 !$OMP THREADPRIVATE(pfraclr,pfracld)
+      REAL, SAVE, ALLOCATABLE :: cldfraliq(:,:)
+!$OMP THREADPRIVATE(cldfraliq)
+      REAL, SAVE, ALLOCATABLE ::mean_icefracturb(:,:)
+!$OMP THREADPRIVATE(mean_icefracturb)
+      REAL, SAVE, ALLOCATABLE :: sigma2_icefracturb(:,:)
+!$OMP THREADPRIVATE(sigma2_icefracturb)
 
 ! variables de sorties MM
@@ -671,10 +708,18 @@
 !
 ! variables for stratospheric aerosol
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: d_q_emiss
+!$OMP THREADPRIVATE(d_q_emiss)
       REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: R2SO4
 !$OMP THREADPRIVATE(R2SO4)
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: R2SO4B
+!$OMP THREADPRIVATE(R2SO4B)
       REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: DENSO4
 !$OMP THREADPRIVATE(DENSO4)
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:, :) :: DENSO4B
+!$OMP THREADPRIVATE(DENSO4B)      
       REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: f_r_wet
 !$OMP THREADPRIVATE(f_r_wet)
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:, :) :: f_r_wetB
+!$OMP THREADPRIVATE(f_r_wetB)
       REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: decfluxaer
 !$OMP THREADPRIVATE(decfluxaer)
@@ -685,4 +730,8 @@
       REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: SO2_lifetime
 !$OMP THREADPRIVATE(SO2_lifetime)
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: H2SO4_lifetime
+!$OMP THREADPRIVATE(H2SO4_lifetime)
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: O3_clim
+!$OMP THREADPRIVATE(O3_clim)
       REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: alpha_bin
 !$OMP THREADPRIVATE(alpha_bin)
@@ -701,4 +750,19 @@
       REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: vsed_aer
 !$OMP THREADPRIVATE(vsed_aer)
+!     Sulfate aerosol concentration (dry mixing ratio) (condensed H2SO4 mmr)
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: sulfmmr
+!$OMP THREADPRIVATE(sulfmmr)
+!     SAD all aerosols (cm2/cm3)
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: SAD_sulfate
+!$OMP THREADPRIVATE(SAD_sulfate)
+!     Effective radius of wet surface aerosols (cm)
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: reff_sulfate
+!$OMP THREADPRIVATE(reff_sulfate)
+!     sulfate MMR in different modes (based on sulfmmr, it must be dry mmr)
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: sulfmmr_mode
+!$OMP THREADPRIVATE(sulfmmr_mode)
+!     particle concentration in different modes (part/m3)
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: nd_mode
+!$OMP THREADPRIVATE(nd_mode)
 !
 !---3D budget variables
@@ -749,5 +813,5 @@
 SUBROUTINE phys_local_var_init
 USE dimphy
-USE infotrac_phy, ONLY : nbtr
+USE infotrac_phy, ONLY : nbtr,nqtot
 #ifdef ISO
 USE infotrac_phy, ONLY : ntraciso=>ntiso,niso
@@ -757,12 +821,20 @@
 USE phys_output_var_mod
 USE phys_state_var_mod
+#ifdef CPP_StratAer
+USE infotrac_phy, ONLY : nbtr_bin
+#endif
 
 IMPLICIT NONE
       ALLOCATE(t_seri(klon,klev),q_seri(klon,klev),ql_seri(klon,klev),qs_seri(klon,klev), qbs_seri(klon,klev))
+! SN 4D ISO
+      ALLOCATE(qx_seri(klon,klev,nqtot))
+! SN
       ALLOCATE(u_seri(klon,klev),v_seri(klon,klev))
       ALLOCATE(cf_seri(klon,klev),rvc_seri(klon,klev))
       ALLOCATE(l_mixmin(klon,klev+1,nbsrf),l_mix(klon,klev+1,nbsrf),wprime(klon,klev+1,nbsrf))
       ALLOCATE(pbl_eps(klon,klev+1,nbsrf+1))
+      ALLOCATE(tke_shear(klon,klev+1,nbsrf), tke_buoy(klon,klev+1,nbsrf), tke_trans(klon,klev+1,nbsrf))
       pbl_eps(:,:,:)=0.
+      tke_shear(:,:,:)=0.; tke_buoy(:,:,:)=0.; tke_trans(:,:,:)=0.
       l_mix(:,:,:)=0.;l_mixmin(:,:,:)=0.;wprime(:,:,:)=0. ! doit etre initialse car pas toujours remplis
       ALLOCATE(rhcl(klon,klev))
@@ -789,4 +861,7 @@
       ALLOCATE(d_u_ajs(klon,klev),d_v_ajs(klon,klev))
       ALLOCATE(d_t_eva(klon,klev),d_q_eva(klon,klev))
+! SN 4D ISO
+      ALLOCATE(d_qx_eva(klon,klev,nqtot))
+! SN 
       ALLOCATE(d_ql_eva(klon,klev),d_qi_eva(klon,klev))
       ALLOCATE(d_t_lscst(klon,klev),d_q_lscst(klon,klev))
@@ -795,5 +870,5 @@
       ALLOCATE(d_t_vdf(klon,klev),d_q_vdf(klon,klev),d_t_diss(klon,klev))
       ALLOCATE (d_qbs_vdf(klon,klev))
-      ALLOCATE(d_t_bs(klon,klev),d_q_bs(klon,klev),d_qbs_bs(klon,klev))
+      ALLOCATE(d_t_bsss(klon,klev),d_q_bsss(klon,klev),d_qbs_bsss(klon,klev))
       ALLOCATE(d_t_vdf_w(klon,klev),d_q_vdf_w(klon,klev))
       ALLOCATE(d_t_vdf_x(klon,klev),d_q_vdf_x(klon,klev))
@@ -802,7 +877,9 @@
       allocate(xtl_seri(ntraciso,klon,klev))
       allocate(xts_seri(ntraciso,klon,klev))
+      allocate(xtbs_seri(ntraciso,klon,klev))
       allocate(d_xt_dyn(ntraciso,klon,klev))
       allocate(d_xtl_dyn(ntraciso,klon,klev))
       allocate(d_xts_dyn(ntraciso,klon,klev))
+      allocate(d_xtbs_dyn(ntraciso,klon,klev))
       allocate(d_xt_con(ntraciso,klon,klev))
       allocate(d_xt_wake(ntraciso,klon,klev))
@@ -835,4 +912,5 @@
       ALLOCATE(d_u_lif(klon,klev),d_v_lif(klon,klev))
       ALLOCATE(d_ts(klon,nbsrf), d_tr(klon,klev,nbtr))
+
 ! Special RRTM
       ALLOCATE(ZLWFT0_i(klon,klev+1),ZSWFT0_i(klon,klev+1),ZFLDN0(klon,klev+1))
@@ -913,4 +991,16 @@
       ALLOCATE(toplwad0_aerop(klon), sollwad0_aerop(klon))
 
+!AI Ajout Ecrad (3Deffect)
+      ALLOCATE(topswad_aero_s2(klon), solswad_aero_s2(klon))
+      ALLOCATE(topswai_aero_s2(klon), solswai_aero_s2(klon))
+      ALLOCATE(topswad0_aero_s2(klon), solswad0_aero_s2(klon))
+      ALLOCATE(topsw_aero_s2(klon,naero_grp), topsw0_aero_s2(klon,naero_grp))
+      ALLOCATE(solsw_aero_s2(klon,naero_grp), solsw0_aero_s2(klon,naero_grp))
+      ALLOCATE(topswcf_aero_s2(klon,naero_grp), solswcf_aero_s2(klon,naero_grp))
+! additional LW variables CK
+      ALLOCATE(toplwad_aero_s2(klon), sollwad_aero_s2(klon))
+      ALLOCATE(toplwai_aero_s2(klon), sollwai_aero_s2(klon))
+      ALLOCATE(toplwad0_aero_s2(klon), sollwad0_aero_s2(klon))
+
 ! FH Ajout de celles necessaires au phys_output_write_mod
 
@@ -923,5 +1013,5 @@
       ALLOCATE(wake_omg(klon, klev))
       ALLOCATE(d_deltat_wk(klon, klev), d_deltaq_wk(klon, klev))
-      ALLOCATE(d_s_wk(klon), d_dens_a_wk(klon), d_dens_wk(klon))
+      ALLOCATE(d_s_wk(klon), d_s_a_wk(klon), d_dens_wk(klon), d_dens_a_wk(klon))
       ALLOCATE(d_deltat_wk_gw(klon, klev), d_deltaq_wk_gw(klon, klev))
       ALLOCATE(d_deltat_vdf(klon, klev), d_deltaq_vdf(klon, klev))
@@ -958,5 +1048,7 @@
       ALLOCATE(zxfqcalving(klon), zxfluxlat(klon))
       ALLOCATE(zxtsol(klon), snow_lsc(klon), zxfqfonte(klon), zxqsurf(klon))
-      ALLOCATE(zxrunofflic(klon))
+! SN add runoff_diag
+      ALLOCATE(zxrunofflic(klon), runoff_diag(klon))
+      runoff_diag(:)=0.
       ALLOCATE(zxustartlic(klon), zxrhoslic(klon), zxqsaltlic(klon))
       zxustartlic(:)=0. ; zxrhoslic(:)=0. ; zxqsaltlic(:)=0.
@@ -973,5 +1065,7 @@
       ALLOCATE(xtrain_lsc(ntraciso,klon))
       ALLOCATE(xtrunoff_diag(niso,klon))
-      ALLOCATE(h1_diag(klon),runoff_diag(klon))
+      ALLOCATE(h1_diag(klon))
+!SN
+      xtrunoff_diag(:,:)=0. ! because variables are only given values on knon grid points
 #endif
 !
@@ -1032,24 +1126,23 @@
       ALLOCATE(wfevap(klon, nbsrf))
       ALLOCATE(evap_pot(klon, nbsrf))
-! FC
+! FC 
       ALLOCATE(zxfluxq(klon,klev),zxfluxt(klon,klev))
-!
 !
 !  Deep convective variables used in phytrac
       ALLOCATE(pmflxr(klon, klev+1), pmflxs(klon, klev+1))
       ALLOCATE(wdtrainA(klon,klev),wdtrainS(klon,klev),wdtrainM(klon,klev))
-      ALLOCATE(dnwd(klon, klev), upwd(klon, klev) )
+      ALLOCATE(dnwd(klon, klev), upwd(klon, klev))
       ALLOCATE(ep(klon,klev))                          ! epmax_cape
-      ALLOCATE(da(klon,klev), mp(klon,klev) )
-      ALLOCATE(phi(klon,klev,klev) )
-      ALLOCATE(wght_cvfd(klon,klev) )
-      ALLOCATE(phi2(klon,klev,klev) )
+      ALLOCATE(da(klon,klev), mp(klon,klev))
+      ALLOCATE(phi(klon,klev,klev))
+      ALLOCATE(wght_cvfd(klon,klev))
+      ALLOCATE(phi2(klon,klev,klev))
       ALLOCATE(d1a(klon,klev), dam(klon,klev))
-      ALLOCATE(ev(klon,klev) )
-      ALLOCATE(elij(klon,klev,klev) )
-      ALLOCATE(qtaa(klon,klev) )
-      ALLOCATE(clw(klon,klev) )
-      ALLOCATE(epmlmMm(klon,klev,klev), eplaMm(klon,klev) )
-      ALLOCATE(sij(klon,klev,klev) )
+      ALLOCATE(ev(klon,klev))
+      ALLOCATE(elij(klon,klev,klev))
+      ALLOCATE(qtaa(klon,klev))
+      ALLOCATE(clw(klon,klev))
+      ALLOCATE(epmlmMm(klon,klev,klev), eplaMm(klon,klev))
+      ALLOCATE(sij(klon,klev,klev))
 #ifdef ISO
       ALLOCATE(xtwdtrainA(ntraciso,klon,klev))
@@ -1094,4 +1187,7 @@
       ALLOCATE(pfraclr(klon,klev),pfracld(klon,klev))
       pfraclr(:,:)=0. ; pfracld(:,:)=0. ! because not always defined
+      ALLOCATE(cldfraliq(klon,klev))
+      ALLOCATE(sigma2_icefracturb(klon,klev))
+      ALLOCATE(mean_icefracturb(klon,klev))
       ALLOCATE(distcltop(klon,klev))
       ALLOCATE(temp_cltop(klon,klev))
@@ -1134,7 +1230,11 @@
 
 #ifdef CPP_StratAer
+      ALLOCATE (d_q_emiss(klon,klev))
       ALLOCATE (R2SO4(klon,klev))
+      ALLOCATE (R2SO4B(klon,klev,nbtr_bin))
       ALLOCATE (DENSO4(klon,klev))
+      ALLOCATE (DENSO4B(klon,klev,nbtr_bin))
       ALLOCATE (f_r_wet(klon,klev))
+      ALLOCATE (f_r_wetB(klon,klev,nbtr_bin))
       ALLOCATE (decfluxaer(klon,nbtr))
       ALLOCATE (mdw(nbtr))
@@ -1147,4 +1247,6 @@
       ALLOCATE (OCS_lifetime(klon,klev))
       ALLOCATE (SO2_lifetime(klon,klev))
+      ALLOCATE (H2SO4_lifetime(klon,klev))
+      ALLOCATE (O3_clim(klon,klev))
       ALLOCATE (alpha_bin(nbands_sw_rrtm+nbands_lw_rrtm+nwave,nbtr))
       ALLOCATE (piz_bin(nbands_sw_rrtm+nbands_lw_rrtm+nwave,nbtr))
@@ -1171,4 +1273,9 @@
       ALLOCATE (surf_PM25_sulf(klon))
       ALLOCATE (vsed_aer(klon,klev))
+      ALLOCATE (sulfmmr(klon,klev))
+      ALLOCATE (SAD_sulfate(klon,klev))
+      ALLOCATE (reff_sulfate(klon,klev))
+      ALLOCATE (sulfmmr_mode(klon,klev,nbtr_bin))
+      ALLOCATE (nd_mode(klon,klev,nbtr_bin))
 #endif
 
@@ -1181,7 +1288,11 @@
 IMPLICIT NONE
       DEALLOCATE(t_seri,q_seri,ql_seri,qs_seri, qbs_seri)
+! SN 4D ISO
+      DEALLOCATE(qx_seri)
+! SN
       DEALLOCATE(u_seri,v_seri)
       DEALLOCATE(cf_seri,rvc_seri)
       DEALLOCATE(l_mixmin,l_mix,wprime)
+      DEALLOCATE(tke_shear,tke_buoy,tke_trans)
       DEALLOCATE(pbl_eps)
       DEALLOCATE(rhcl)
@@ -1208,4 +1319,7 @@
       DEALLOCATE(d_u_ajs,d_v_ajs)
       DEALLOCATE(d_t_eva,d_q_eva)
+! SN 4D ISO
+      DEALLOCATE(d_qx_eva)
+! SN
       DEALLOCATE(d_ql_eva,d_qi_eva)
       DEALLOCATE(d_t_lscst,d_q_lscst)
@@ -1214,9 +1328,9 @@
       DEALLOCATE(d_t_vdf,d_q_vdf,d_t_diss)
       DEALLOCATE(d_qbs_vdf)
-      DEALLOCATE(d_t_bs,d_q_bs,d_qbs_bs)
-#ifdef ISO
-      deallocate(xt_seri,xtl_seri,xts_seri)
+      DEALLOCATE(d_t_bsss,d_q_bsss,d_qbs_bsss)
+#ifdef ISO
+      deallocate(xt_seri,xtl_seri,xts_seri,xtbs_seri)
       DEALLOCATE(d_xtl_eva,d_xti_eva)
-      deallocate(d_xt_dyn,d_xtl_dyn,d_xts_dyn)
+      deallocate(d_xt_dyn,d_xtl_dyn,d_xts_dyn,d_xtbs_dyn)
       deallocate(d_xt_con)
       deallocate(d_xt_wake)
@@ -1308,5 +1422,4 @@
       DEALLOCATE(solsw_aerop, solsw0_aerop)
       DEALLOCATE(topswcf_aerop, solswcf_aerop)
-
 !CK LW diagnostics
       DEALLOCATE(toplwad_aerop, sollwad_aerop)
@@ -1314,4 +1427,16 @@
       DEALLOCATE(toplwad0_aerop, sollwad0_aerop)
 
+!AI Ajout pour Ecrad (3Deffect)
+      DEALLOCATE(topswad_aero_s2, solswad_aero_s2)
+      DEALLOCATE(topswai_aero_s2, solswai_aero_s2)
+      DEALLOCATE(topswad0_aero_s2, solswad0_aero_s2)
+      DEALLOCATE(topsw_aero_s2, topsw0_aero_s2)
+      DEALLOCATE(solsw_aero_s2, solsw0_aero_s2)
+      DEALLOCATE(topswcf_aero_s2, solswcf_aero_s2)
+!CK LW diagnostics
+      DEALLOCATE(toplwad_aero_s2, sollwad_aero_s2)
+      DEALLOCATE(toplwai_aero_s2, sollwai_aero_s2)
+      DEALLOCATE(toplwad0_aero_s2, sollwad0_aero_s2)      
+
 ! FH Ajout de celles necessaires au phys_output_write_mod
       DEALLOCATE(tal1, pal1, pab1, pab2)
@@ -1322,5 +1447,5 @@
       DEALLOCATE(wake_omg)
       DEALLOCATE(d_deltat_wk, d_deltaq_wk)
-      DEALLOCATE(d_s_wk, d_dens_a_wk, d_dens_wk)
+      DEALLOCATE(d_s_wk, d_s_a_wk, d_dens_wk, d_dens_a_wk)
       DEALLOCATE(d_deltat_wk_gw, d_deltaq_wk_gw)
       DEALLOCATE(d_deltat_vdf, d_deltaq_vdf)
@@ -1353,5 +1478,6 @@
       DEALLOCATE(uwat, vwat)
       DEALLOCATE(zxfqcalving, zxfluxlat)
-      DEALLOCATE(zxrunofflic)
+! SN runoff_diag
+      DEALLOCATE(zxrunofflic, runoff_diag)
       DEALLOCATE(zxustartlic, zxrhoslic, zxqsaltlic)
       DEALLOCATE(zxtsol, snow_lsc, zxfqfonte, zxqsurf)
@@ -1382,5 +1508,5 @@
       DEALLOCATE(dxtvdf_x, dxtvdf_w)
       DEALLOCATE(xt_therm)
-      DEALLOCATE(h1_diag,runoff_diag,xtrunoff_diag)
+      DEALLOCATE(h1_diag,xtrunoff_diag)
 #endif
 !
@@ -1422,15 +1548,15 @@
       DEALLOCATE(upwd, dnwd)
       DEALLOCATE(ep)
-      DEALLOCATE(da, mp )
-      DEALLOCATE(phi )
-      DEALLOCATE(wght_cvfd )
-      DEALLOCATE(phi2 )
+      DEALLOCATE(da, mp)
+      DEALLOCATE(phi)
+      DEALLOCATE(wght_cvfd)
+      DEALLOCATE(phi2)
       DEALLOCATE(d1a, dam)
-      DEALLOCATE(ev )
-      DEALLOCATE(elij )
-      DEALLOCATE(qtaa )
-      DEALLOCATE(clw )
-      DEALLOCATE(epmlmMm, eplaMm )
-      DEALLOCATE(sij )
+      DEALLOCATE(ev)
+      DEALLOCATE(elij)
+      DEALLOCATE(qtaa)
+      DEALLOCATE(clw)
+      DEALLOCATE(epmlmMm, eplaMm)
+      DEALLOCATE(sij)
 #ifdef ISO
       DEALLOCATE(xtwdtrainA)
@@ -1472,7 +1598,10 @@
       DEALLOCATE(rneb)
       DEALLOCATE(pfraclr,pfracld)
+      DEALLOCATE(cldfraliq)
+      DEALLOCATE(sigma2_icefracturb)
+      DEALLOCATE(mean_icefracturb)
+      DEALLOCATE (zxsnow,snowhgt,qsnow,to_ice,sissnow,runoff,albsol3_lic)
       DEALLOCATE(distcltop)
       DEALLOCATE(temp_cltop)
-      DEALLOCATE (zxsnow,snowhgt,qsnow,to_ice,sissnow,runoff,albsol3_lic)
 #ifdef ISO
       DEALLOCATE (zxxtsnow,xtVprecip,xtVprecipi,pxtrfl,pxtsfl)
@@ -1507,11 +1636,14 @@
 #ifdef CPP_StratAer
 ! variables for strat. aerosol CK
-      DEALLOCATE (R2SO4)
-      DEALLOCATE (DENSO4)
-      DEALLOCATE (f_r_wet)
+      DEALLOCATE (d_q_emiss)
+      DEALLOCATE (R2SO4, R2SO4B)
+      DEALLOCATE (DENSO4, DENSO4B)
+      DEALLOCATE (f_r_wet, f_r_wetB)
       DEALLOCATE (decfluxaer)
       DEALLOCATE (mdw)
       DEALLOCATE (SO2_lifetime)
       DEALLOCATE (OCS_lifetime)
+      DEALLOCATE (H2SO4_lifetime)
+      DEALLOCATE (O3_clim)
       DEALLOCATE (alpha_bin)
       DEALLOCATE (piz_bin)
@@ -1522,4 +1654,9 @@
       DEALLOCATE (surf_PM25_sulf)
       DEALLOCATE (vsed_aer)
+      DEALLOCATE (sulfmmr)
+      DEALLOCATE (SAD_sulfate)
+      DEALLOCATE (reff_sulfate)
+      DEALLOCATE (sulfmmr_mode)
+      DEALLOCATE (nd_mode)
       DEALLOCATE (budg_3D_ocs_to_so2)
       DEALLOCATE (budg_3D_so2_to_h2so4)
Index: /LMDZ6/branches/cirrus/libf/phylmdiso/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmdiso/phys_output_ctrlout_mod.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/phylmdiso/phys_output_ctrlout_mod.F90	(revision 5202)
@@ -1112,6 +1112,13 @@
   TYPE(ctrl_out), SAVE :: o_tke = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'tke ', 'TKE', 'm2/s2', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_tke_shear = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'tke_shear ', 'TKE shear term', 'm2/s3', (/ ('', i=1, 10) /))  
+  TYPE(ctrl_out), SAVE :: o_tke_buoy = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'tke_buoy ', 'TKE buoyancy term', 'm2/s3', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_tke_trans = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'tke_trans ', 'TKE transport term', 'm2/s3', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_tke_dissip = ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'tke_dissip ', 'TKE DISSIPATION', 'm2/s3', (/ ('', i=1, 10) /))   
+    'tke_dissip ', 'TKE dissipation term', 'm2/s3', (/ ('', i=1, 10) /))
+
   TYPE(ctrl_out), SAVE :: o_tke_max = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'tke_max', 'TKE max', 'm2/s2',                                  &
@@ -1442,4 +1449,12 @@
   TYPE(ctrl_out), SAVE :: o_tau_strat_1020 = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
     'OD1020_strat_only', 'Stratospheric Aerosol Optical depth at 1020 nm ', '1', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_SAD_sulfate = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
+    'SAD_sulfate', 'SAD WET sulfate aerosols', 'cm2/cm3', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_reff_sulfate = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
+    'reff_sulfate', 'Effective radius of WET sulfate aerosols', 'cm', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_sulfmmr = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
+    'sulfMMR', 'Sulfate aerosol concentration (dry mass mixing ratio)', 'kg(H2SO4)/kg(air)', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_nd_mode(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_sulfmmr_mode(:)
 !--chemistry
   TYPE(ctrl_out), SAVE :: o_R2SO4 = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 1/), &
@@ -1551,4 +1566,11 @@
   TYPE(ctrl_out), SAVE :: o_rneb = ctrl_out((/ 2, 5, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'rneb', 'Cloud fraction', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_cldfraliq = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'cldfraliq', 'Liquid fraction of the cloud', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_sigma2_icefracturb = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'sigma2_icefracturb', 'Variance of the diagnostic supersaturation distribution (icefrac_turb) [-]', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_mean_icefracturb = ctrl_out((/ 11, 11, 11, 11, 11, 11, 11, 11, 11, 11/), &
+    'mean_icefracturb', 'Mean of the diagnostic supersaturation distribution (icefrac_turb) [-]', '-', (/ ('', i=1, 10) /))
+ 
   TYPE(ctrl_out), SAVE :: o_rnebjn = ctrl_out((/ 2, 5, 10, 10, 10, 10, 11, 11,11, 11/), &      
     'rnebjn', 'Cloud fraction in day', '-', (/ ('', i=1, 10) /))
@@ -1981,5 +2003,4 @@
   TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dtr_dry(:)
 
-
 #ifdef ISO
   TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtprecip(:)
@@ -1991,4 +2012,5 @@
   TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtoliq(:)
   TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtcond(:)
+  TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_xtrunoff_diag(:)
   TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtdyn(:)
   TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_dxtldyn(:)
@@ -2088,4 +2110,9 @@
   TYPE(ctrl_out), SAVE :: o_runoff = ctrl_out((/ 1, 1, 10, 1, 10, 10, 11, 11, 11, 11/), &
     'runoff', 'Run-off rate land ice', 'kg/m2/s', (/ ('', i=1, 10) /))
+! SN add runoff_diag
+!#ifdef ISO
+  TYPE(ctrl_out), SAVE :: o_runoff_diag = ctrl_out((/ 1, 1, 10, 1, 10, 10, 11, 11, 11, 11/), &
+    'runoffland', 'Run-off rate land for bucket', 'kg/m2/s', (/ ('', i=1, 10) /))
+!#endif
   TYPE(ctrl_out), SAVE :: o_albslw3 = ctrl_out((/ 1, 1, 1, 1, 10, 10, 11, 11, 11, 11/), &
     'albslw3', 'Surface albedo LW3', '-', (/ ('', i=1, 10) /))
